datablock ParticleData(TestGrid)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.0;

   lifetimeMS           = 2000;
   lifetimeVarianceMS   = 0;

   spinRandomMin = 350.0;
   spinRandomMax = 370.0;
   windcoefficient = 0;
   textureName          = "special/GameGrid";


   colors[0]     = "0.5 0.5 1.0 1";
   colors[1]     = "0.5 0.5 1.0 1";
   colors[2]     = "0.5 0.5 1.0 1";
   colors[3]     = "0.5 0.5 1.0 1";

   sizes[0]      = 20;
   sizes[1]      = 10;
   sizes[2]      = 5;
   sizes[3]      = 1;

   times[0]      = 0.25;
   times[1]      = 0.5;
   times[2]      = 0.75;
   times[3]      = 1;


};

datablock ParticleEmitterData(TestGridEmitter)
{
   lifetimeMS        = 0;
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionoffset = 20;
   thetaMin         = 0.0;
   thetaMax         = 0.0;

   phiReferenceVel = "180";
   phiVariance = "0";
   orientParticles  = false;
   orientOnVelocity = false;

   particles = "TestGrid";
};

datablock ShockwaveData(FZShockWave) {
	className = "ShockwaveData";
	delayMS = "0";
	delayVariance = "0";
	lifetimeMS = "8000";
	lifetimeVariance = "0";
	width = "5";
	numSegments = "80";
	numVertSegments = "10";
	velocity = "-200";
	height = "62";
	verticalCurve = "2.5";
	acceleration = "50";
	times[0] = "0";
	times[1] = "0.5";
	times[2] = "1";
	times[3] = "1";
	colors[0] = "1.000000 1.000000 1.000000 0.100000"; //1.0 0.9 0.9
	colors[1] = "1.000000 1.000000 1.000000 1.000000"; //0.6 0.6 0.6
	colors[2] = "1.000000 1.000000 1.000000 0.100000"; //0.6 0.6 0.6
	colors[3] = "1.000000 1.000000 1.000000 1.000000";
	texture[0] = "special/whitenoAlpha";
	texture[1] = "special/whitenoAlpha";
	texWrap = "7";
	orientToNormal = "1";
	renderBottom = "1";
        mapToTerrain = "0";
};

datablock ExplosionData(FZExplosion):BaseExplosion
          {
     	  Shockwave = "FZShockWave";
};

datablock TracerProjectileData(FZProjectile):BaseProjectile
        {
	Explosion = "FZExplosion";
};

datablock ParticleData(PreZeroParticle) {
	dragCoefficient = 0;
	gravityCoefficient = 0;
	windCoefficient = 0;
	inheritedVelFactor = 0;
	constantAcceleration = 1;
	lifetimeMS = 12000;
	lifetimeVarianceMS = 6000;
	useInvAlpha = 0;
	spinRandomMin = 0;
	spinRandomMax = 0;
	textureName = "special/bluespark.PNG";
	times[0] = 0.75;
	times[1] = 2;
	colors[0] = "1 0.5 1 1";
	colors[1] = " 0 0 0 0";
	sizes[0] = 1;
	sizes[1] = 1;
};

datablock ParticleEmitterData(PreZeroEmitter) {
	ejectionPeriodMS = 2;
	periodVarianceMS = 1;
	ejectionVelocity = 30;
	velocityVariance = 10;
	ejectionOffset   = 8;
	thetaMin = 0;
	thetaMax = 180;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvances = 0;
	orientParticles= 1;
	orientOnVelocity = 1;
	particles = "PreZeroParticle";
};

datablock ShockwaveData(FZendShockwave)
        {
	className = "ShockwaveData";
	delayMS = "0";
	delayVariance = "0";
	lifetimeMS = "10000";
	lifetimeVariance = "0";
	width = "300";
	numSegments = "80";
	numVertSegments = "10";
	velocity = "60";
	height = "30";
	verticalCurve = "10";
	acceleration = "0";
	times[0] = "0";
	times[1] = "0.1";
	times[2] = "0.5";
	times[3] = "1";
	colors[0] = "0.500000 0.000000 0.500000 0.100000"; //1.0 0.9 0.9
	colors[1] = "1.000000 0.800000 1.000000 1.000000"; //0.6 0.6 0.6
	colors[2] = "1.000000 0.800000 1.000000 1.000000"; //0.6 0.6 0.6
	colors[3] = "1.000000 1.000000 1.000000 0.000000";
	texture[0] = "special/shockwave4";
	texture[1] = "special/gradient";
	texWrap = "7";
	orientToNormal = "1";
	renderBottom = "1";
        mapToTerrain = "0";
};

datablock ExplosionData(FZendExplosion):BaseExplosion
          {
     	  Shockwave = "FZendShockwave";
          };

datablock TracerProjectileData(FZendProjectile):BaseProjectile
        {
	Explosion = "FZendExplosion";
        };

function foreverzero(%pos) {
	for (%i=0; %i < 10;%i++)
    	{
	    %nrm = mCos(%i*$pi/10) SPC mSin(%i*$pi/10) SPC 0;
	    shockwave(VectorAdd(%pos,VectorScale(%nrm,49)),%nrm,"FZProjectile");
	    shockwave(VectorAdd(%pos,VectorScale(%nrm,-49)),VectorScale(%nrm,-1),"FZProjectile");
    	}
	schedule(4000,0,"whiteout", %pos, 0, 390);
	schedule(4001,0,"eventhorizon",%pos);
	schedule(7000,0,"endwave",%pos);
}

function endwave(%pos) {
	%ang = GetRandom()*2*$pi;
	%pos2=%pos;
	%nrm = VectorNormalize(mCos(%ang) SPC mSin(%ang) SPC 2);
	Schedule(1000,0,"shockwave",VectorAdd(%pos,VectorScale(%nrm,-1)),VectorNormalize(mCos(%ang) SPC mSin(%ang) SPC 1.5),"FZendProjectile");
//	Schedule(1000,0,"shockwave",VectorAdd(%pos,VectorScale(%nrm,-1)),VectorNormalize(mCos(%ang) SPC mSin(%ang) SPC 3),"FZendProjectile");
}


function eventhorizon(%pos) {
	for (%n=0; %n < 400; %n++) {
		InitContainerRadiusSearch(%pos,390, $TypeMasks::ProjectileObjectType | $TypeMasks::VehicleObjectType |$TypeMasks::StaticShapeObjectType | $TypeMasks::PlayerObjectType| $TypeMasks::ItemObjectType | $TypeMasks::CorpseObjectType);
		while ((%wham = containersearchnext()) != 0) {
			if (%wham.getType() & $TypeMasks::StaticShapeObjectType) {
				if (!$host::invincibleDeployables) {
					if (%wham.team != 0) {
						%wham.settransform("-9999 -9999 -9999");
						schedule(50,0,"depexecution",%wham);
					}
				}
			}
			if (%wham.getType() & $TypeMasks::VehicleObjectType) {
				%wham.settransform("-9999 -9999 -9999");
				schedule(50,0,"vehexecution",%wham);
			}
			if (%wham.getType() & $TypeMasks::ProjectileObjectType) {
				%wham.delete();
			}
			if (%wham.getType() & $TypeMasks::ItemObjectType) {
				%wham.settransform("-9999 -9999 -9999");
			}
			if (%wham.getType() & $TypeMasks::CorpseObjectType) {
				%wham.settransform("-9999 0 -9999");
			}
			if (%wham.getType() & $TypeMasks::PlayerObjectType) {
				plexecution(%wham);
			}
		}
	}
}

function depexecution(%dep) {
	%wham.setDamageState("Destroyed");
}

function vehexecution(%veh) {
	for(%i = 0; %i < %obj.getDatablock().numMountPoints; %i++)
	if (%obj.getMountNodeObject(%i)) {
		%passenger = %obj.getMountNodeObject(%i);
	        %passenger.unmount();
		plexecution(%passenger);
	}
	%wham.setDamageState("Destroyed");
}

function plexecution(%pl) {
		%vec=getrandom(-9999,9999) SPC getrandom(-9999,9999) SPC getrandom(-20000,-10000);
		%pl.settransform(%vec);
		%pl.scriptkill($damagetype::foreverzero);
		%pl.setWhiteOut( 1 );
}
