//**************************************************************
// SHRIKE SCOUT FLIER
//**************************************************************
datablock StaticShapeData(solid) : StaticShapeDamageProfile
{
className = solid;
shapeFile = "stackable1m.dts"; // dmiscf.dts, alternate
maxDamage = 1.7;
destroyedLevel = 1.7;
disabledLevel = 1.7;
teamPermiable = true;
otherPermiable = false;
explosion = DeployablesExplosion;
dynamicType = $TypeMasks::StaticShapeObjectType;
deployedObject = false;
cmdCategory = "DSupport";
cmdIcon = CMDSensorIcon;
cmdMiniIconName = "commander/MiniIcons/com_deploymotionsensor";
targetNameTag = 'weird';
targetTypeTag = 'thing';
deployAmbientThread = false;
debrisShapeName = "debris_generic_small.dts";
debris = DeployableDebris;
heatSignature = 0;
repairRate     = 0.02;
};
//**************************************************************
// images
//*************************************************************
datablock ShapeBaseImageData(ac1image)
{
       catagory = "Misc";
       shapeFile = "nexusbase.dts";
       offset = " -0.3 0 0.5";
       size = "1 0.5 6";
       rotation = "0 1 0 90";
       alwaysAmbient = true;
 };

datablock ShapeBaseImageData(ac2image)
 {
       catagory = "Misc";
       shapeFile = "nexusbase.dts";
       offset = " 0.3 0 0.5";
       size = "2 2 2";
       rotation = "0 -1 0 90";
       alwaysAmbient = true;
 };
 datablock ShapeBaseImageData(ac5image)
 {
       catagory = "Misc";
       shapeFile = "nexuscap.dts";
       offset = " -0.02 0 0.5";
       size = "2 2 2";
       rotation = "0 -1 0 90";
       alwaysAmbient = true;
 };
  datablock ShapeBaseImageData(ac6image)
 {
       catagory = "Misc";
       shapeFile = "nexuscap.dts";
       offset = " 0.02 0 0.5";
       size = "2 2 2";
       rotation = "0 1 0 90";
       alwaysAmbient = true;
 };
//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

datablock HoverVehicleData(aircycle) : aircycleDamageProfile
{
   spawnOffset = "0 0 2";
   canControl = true;
   catagory = "Vehicles";
   shapeFile = "teamlogo_projector.dts";
   multipassenger = false;
   computeCRC = true;
   floatingGravMag = 0.1;

   debrisShapeName = "vehicle_grav_scout_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag = 0.0;
   density = 5.0;

   mountPose[0] = scoutRoot;
   cameraMaxDist = 5.0;
   cameraOffset = 0.7;
   cameraLag = 0.5;
   numMountPoints = 1;
   isProtectedMountPoint[0] = true;
   explosion = VehicleExplosion;
	explosionDamage = 0.5;
	explosionRadius = 5.0;

   lightOnly = 1;

   maxDamage = 1.60;
   destroyedLevel = 1.50;

   isShielded = true;
   rechargeRate = 0.2;
   energyPerDamagePoint = 45;
   maxEnergy = 200;
   minJetEnergy = 10;
   jetEnergyDrain = 8.0;

   // Rigid Body
   mass = 800;
   bodyFriction = 0.9;
   bodyRestitution = 0.9;
   minRollSpeed = 10;
   gyroForce = 300;
   gyroDamping = 0.3;
   stabilizerForce = 20;
   minDrag = 10;
   softImpactSpeed = 15;       // Play SoftImpact Sound
   hardImpactSpeed = 18;      // Play HardImpact Sound

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 17;
   speedDamageScale = 0.060;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 18;
   collDamageMultiplier   = 0.045;

   dragForce            = 40 / 20;
   vertFactor           = 0.1;
   floatingThrustFactor = 0.1;

   mainThrustForce    = 10;
   reverseThrustForce = 10;
   strafeThrustForce  = 0.01;
   turboFactor        = 0.5;

   brakingForce = 100;
   brakingActivationSpeed = 0;

   stabLenMin = 3.25;
   stabLenMax = 4;
   stabSpringConstant  = 10;
   stabDampingConstant = 10;

   gyroDrag = 10;
   normalForce = 10;
   restorativeForce = 10;
   steeringForce = 15;
   rollForce  = 10;
   pitchForce = 10;

   dustEmitter = TankDustEmitter;
   triggerDustHeight = 1.5;
   dustHeight = 0.3;
   dustTrailEmitter = TireEmitter;
   dustTrailOffset = "0.0 -1.0 0.5";
   triggerTrailHeight = 3.6;
   dustTrailFreqMod = 15.0;

   jetSound         = AssaultVehicleThrustSound;
   engineSound      = AssaultVehicleEngineSound;
   floatSound       = AssaultVehicleSkid;
   softImpactSound  = GravSoftImpactSound;
   hardImpactSound  = HardImpactSound;
   wheelImpactSound = WheelImpactSound;

   forwardJetEmitter = TankJetEmitter;

   //
   softSplashSoundVelocity = 5.0;
   mediumSplashSoundVelocity = 10.0;
   hardSplashSoundVelocity = 15.0;
   exitSplashSoundVelocity = 10.0;

   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound;

   minMountDist = 8;

   damageEmitter[0] = SmallLightDamageSmoke;
   damageEmitter[1] = SmallHeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -1.5 3.5 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDGroundTankIcon;
   cmdMiniIconName = "commander/MiniIcons/com_tank_grey";
   targetNameTag = 'fire';
   targetTypeTag = 'Tank';
   sensorData = VehiclePulseSensor;

   checkRadius = 5.5535;
   observeParameters = "1 10 10";
   runningLight[0] = TankLight1;
   runningLight[1] = TankLight2;
   runningLight[2] = TankLight3;
   runningLight[3] = TankLight4;
   shieldEffectScale = "0.9 1.0 0.6";
   showPilotInfo = 1;
};

//**************************************************************
// WEAPONS        %obj.teleportStartFX()
//**************************************************************

datablock ShapeBaseImageData(aircycleChaingunPairImage)
{
   className = WeaponImage;
   shapeFile = "turret_assaulttank_plasma.dts";
   item      = flamer;
   //ammo   = ChaingunAmmo;
   projectile = flamerShot;
   projectileType = GrenadeProjectile;
   mountPoint = 2;
//**original**   offset = ".73 0 0";
   offset = " 0.6 0 0.5";
   rotation = "0 -1 0 90";

   projectileSpread = 1.0 / 1000.0;

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 0.01;
   fireEnergy = 0.01;
   fireTimeout = 0.001;

   stateName[0] = "Activate";
   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   //stateSound[0] = ;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "CheckWet";
   //stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.5;
   stateFire[3] = true;
   //stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
   stateScript[3] = "onFire";
   stateSound[3] = PlasmaProjectileSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.5;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = PlasmaProjectileSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   //stateSound[6]      = ;
   stateTimeoutValue[6]        = 0.5;
   stateTransitionOnTimeout[6] = "NoAmmo";

   stateName[7]       = "WetFire";
   stateSound[7]      = PlasmaFireWetSound;
   stateTimeoutValue[7]        = 0.5;
   stateTransitionOnTimeout[7] = "Ready";

   stateName[8]               = "CheckWet";
   stateTransitionOnWet[8]    = "WetFire";
   stateTransitionOnNotWet[8] = "Fire";
};

datablock ShapeBaseImageData(aircycleChaingunImage) : aircycleChaingunPairImage
{
   projectile = flamerShot;
   projectileType = GrenadeProjectile;
   offset = "-0.6 0 0.5";
   rotation = "0 1 0 90";
   projectileSpread = 1.0 / 1000.0;

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 0.01;
   fireEnergy = 0.03;
   fireTimeout = 0.001;

   stateName[0] = "Activate";
   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   //stateSound[0] = ;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "CheckWet";
   //stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.5;
   stateFire[3] = true;
   //stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
   stateScript[3] = "onFire";
   stateSound[3] = PlasmaProjectileSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.5;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = PlasmaProjectileSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   //stateSound[6]      = ;
   stateTimeoutValue[6]        = 0.5;
   stateTransitionOnTimeout[6] = "NoAmmo";

   stateName[7]       = "WetFire";
   stateSound[7]      = PlasmaFireWetSound;
   stateTimeoutValue[7]        = 0.5;
   stateTransitionOnTimeout[7] = "Ready";

   stateName[8]               = "CheckWet";
   stateTransitionOnWet[8]    = "WetFire";
   stateTransitionOnNotWet[8] = "Fire";
};

datablock ShapeBaseImageData(aircycleChaingunParam)
{
   mountPoint = 3;
   shapeFile = "turret_muzzlepoint.dts";

};
