//**************************************************************
//  vehicle_Starhammer
//**************************************************************

datablock FlyingVehicleData(airtankFlyer) :airtankFlyerDamageProfile
{
   spawnOffset = "0 0 4";

   catagory = "Vehicles";
   shapeFile = "vehicle_grav_tank.dts";
   multipassenger = true;
   computeCRC = true;

   debrisShapeName = "vehicle_grav_tank_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag    = 0.15;
   density = 1.0;

   mountPose[0] = sitting;
   mountPose[1] = stand;
   numMountPoints = 2;
   isProtectedMountPoint[0] = true;
   isProtectedMountPoint[1] = true;
   canControl = true;
   cameraMaxDist = 20;
   cameraOffset = 0.5;
   cameraLag = 0.9;
   explosion = VehicleExplosion;
   explosionDamage = 0.0;
   explosionRadius = 0.0;

   maxDamage = 7.40;
   destroyedLevel = 0.00;

   isShielded = true;
   energyPerDamagePoint = 100;
   maxEnergy = 280;      
   minDrag = 30;           
   rotationalDrag = 900;        
   rechargeRate = 1;

   maxAutoSpeed = 15;       
   autoAngularForce = 600;       
   autoLinearForce = 300;      
   autoInputDamping = 0.95;      
   
   // Maneuvering
   maxSteeringAngle = 6;   
   horizontalSurfaceForce = 7;  
   verticalSurfaceForce = 4;   
   maneuveringForce = 3000;
   steeringForce = 1200;    
   steeringRollForce = 400;    
   rollForce = 6;        
   hoverHeight = 4;    
   createHoverHeight = 6;  
   maxForwardSpeed = 80;  // speed in which forward thrust force is no longer applied (meters/second)
   maxBackwardSpeed = 60;  // speed in which forward thrust force is no longer applied (meters/second)
   // Turbo Jet
   jetForce = 1000;
   minJetEnergy = 28;  
   jetEnergyDrain = 0.01;    
   
   vertThrustMultiple = 3.0;

   // Rigid body
   mass = 150;       
   bodyFriction = 0;    
   bodyRestitution = 0.5; 
   minRollSpeed = 0;    
   softImpactSpeed = 14;     
   hardImpactSpeed = 25;  

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 2013;     
   speedDamageScale = 0.0;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 9999.0;
   collDamageMultiplier   = 0.00;

   //
   //minTrailSpeed = 25; //was 15   
   //trailEmitter = ContrailEmitter;
   //forwardJetEmitter = FlyerJetEmitter;
   downJetEmitter = FlyerJetEmitter;

   //
   jetSound = ScoutFlyerThrustSound;
   engineSound = ScoutFlyerEngineSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;
   
   //
   softSplashSoundVelocity = 10.0; 
   mediumSplashSoundVelocity = 15.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 10.0;
   
   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound; 
    
   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 1.0;
   dustHeight = 0.1;

//   damageEmitter[0] = LightDamageSmoke;
//   damageEmitter[1] = HeavyDamageSmoke;
//   damageEmitter[2] = DamageBubbles;
//   damageEmitterOffset[0] = "0.0 -3.0 0.0 ";
//   damageLevelTolerance[0] = 0.3;
//   damageLevelTolerance[1] = 0.7;
//   numDmgEmitterAreas = 1;

   //
   max[chaingunAmmo] = 10000;

   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDGroundTankIcon;
   cmdMiniIconName = "commander/MiniIcons/com_tank_grey";
   targetNameTag = 'Taxi';
   targetTypeTag = 'Flyng car';
   sensorData = AWACPulseSensor;
   sensorRadius = AWACPulseSensor.detectRadius;
   sensorColor = "255 194 9";
   
   checkRadius = 5.5;
   observeParameters = "1 10 10";

   runningLight[0] = ShrikeLight1;
//   runningLight[1] = ShrikeLight2;

   shieldEffectScale = "0.937 1.125 0.60";

};
