//--------------------------------------------------
// Fire works gun. By: Lt.Earthworm
//--------------------------------------------------

$WeaponModeCount[FireWorks] = 11;

$WeaponMode[FireWorks, 0] = FireWorksRocket;
$WeaponType[FireWorks, 0] = LinearProjectile;
$WeaponDescription[FireWorks, 0] = "Red Fire Works";

$WeaponMode[FireWorks, 1] = FireWorksRocket;
$WeaponType[FireWorks, 1] = LinearProjectile;
$WeaponDescription[FireWorks, 1] = "Green Fire Works";

$WeaponMode[FireWorks, 2] = FireWorksRocket;
$WeaponType[FireWorks, 2] = LinearProjectile;
$WeaponDescription[FireWorks, 2] = "Blue Fire Works";

$WeaponMode[FireWorks, 3] = FireWorksRocket;
$WeaponType[FireWorks, 3] = LinearProjectile;
$WeaponDescription[FireWorks, 3] = "Purple Fire Works";

$WeaponMode[FireWorks, 4] = FireWorksRocket;
$WeaponType[FireWorks, 4] = LinearProjectile;
$WeaponDescription[FireWorks, 4] = "Orange Fire Works";

$WeaponMode[FireWorks, 5] = FireWorksRocket;
$WeaponType[FireWorks, 5] = LinearProjectile;
$WeaponDescription[FireWorks, 5] = "Yellow Fire Works";

$WeaponMode[FireWorks, 6] = FireWorksRocket;
$WeaponType[FireWorks, 6] = LinearProjectile;
$WeaponDescription[FireWorks, 6] = "White Fire Works";

$WeaponMode[FireWorks, 7] = FireWorksRingRocket;
$WeaponType[FireWorks, 7] = LinearProjectile;
$WeaponDescription[FireWorks, 7] = "Sphere With Ring";

$WeaponMode[FireWorks, 8] = "Ha! Like I'm going to give this one a projectile. It's RANDOM!!";
$WeaponType[FireWorks, 8] = LinearProjectile;
$WeaponDescription[FireWorks, 8] = "Random";

$WeaponMode[FireWorks, 9] = "Ha! Like I'm going to give this one a projectile. It's RANDOM!! AND MULTIPLE!!!!!";
$WeaponType[FireWorks, 9] = LinearProjectile;
$WeaponDescription[FireWorks, 9] = "Multiple Random";

$WeaponMode[FireWorks, 10] = FireWorksRocket;
$WeaponType[FireWorks, 10] = LinearProjectile;
$WeaponDescription[FireWorks, 10] = "Finale";

$WeaponName[FireWorks] = "Fun Fire Works";

$randomSparks[0] = "Red";
$randomSparks[1] = "Green";
$randomSparks[2] = "Blue";
$randomSparks[3] = "Purple";
$randomSparks[4] = "Orange";
$randomSparks[5] = "Yellow";
$randomSparks[6] = "White";

$SparkCount = 7;

$RandomRockets[0] = "FireWorksRocket";
$RandomRockets[1] = "FireWorksRingRocket";

function FireWorksImage::onFire(%data, %obj, %slot)
{
	if(%obj.client.mode == 9)
	{
		%p = new LinearProjectile(){
				datablock = $RandomRockets[getRandom(1)];
				sourceObject = %obj;
				sourceSlot = %slot;
				initialDirection = %obj.getMuzzleVector(%slot);
				initialPosition = %obj.getMuzzlePoint(%slot);
			};
		MissionCleanup.add(%p);
		%p.ExpEmitter = $randomSparks[getRandom(0,$SparkCount-1)] @"SparkEmitter";
	}
	else if(%obj.client.mode == 10)
	{
		for(%i = 0; %i < getRandom(5, 10); %i++)
		{
      		%vector = %obj.getMuzzleVector(%slot);
		      %x = (getRandom() - 0.5) * 2 * 3.1415926 * 150/1000;
		      %y = (getRandom() - 0.5) * 2 * 3.1415926 * 150/1000;
		      %z = (getRandom() - 0.5) * 2 * 3.1415926 * 150/1000;
		      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		      %vector = MatrixMulVector(%mat, %vector);

			%p = new LinearProjectile(){
					datablock = $RandomRockets[getRandom(1)];
					sourceObject = %obj;
					sourceSlot = %slot;
					initialDirection = %vector;
					initialPosition = %obj.getMuzzlePoint(%slot);
				};
			MissionCleanup.add(%p);
			%p.ExpEmitter = $randomSparks[getRandom(0,$SparkCount-1)] @"SparkEmitter";
		}
	}
	else if(%obj.client.mode == 11)
	{
		%p = Parent::onFire(%data, %obj, %slot);
		%p.ExpEmitter = $randomSparks[getRandom(0,$SparkCount - 1)] @"SparkEmitter";
		%p.isFinal = true;
	}
	else
	{
		%p = Parent::onFire(%data, %obj, %slot);
		%p.ExpEmitter = $randomSparks[%obj.client.mode - 1] @"SparkEmitter";
	}
}

//-----------------------------
// Sounds
//------------------

datablock AudioDescription(FireWorksExplosion)
{
   volume   = 1;
   isLooping= false;

   is3D     = true;
   minDistance= 400.0;
   MaxDistance= 500.0;
   type     = $EffectAudioType;
   environmentLevel = 1.0;
};

datablock AudioProfile(FireWorksProjectileSound)
{
   filename    = "fx/vehicles/bomber_bomb_projectile.WAV";
   description = ProjectileLooping3d;
   preload = true;
};

datablock AudioProfile(FireWorksExpSound)
{
   filename    = "fx/weapons/spinfusor_impact_UW.WAV";
   description = FireWorksExplosion;
   preload = true;
};

datablock AudioProfile(FireWorksReloadSound)
{
   filename    = "fx/weapons/grenadelauncher_reload.WAV";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(FireWorksFireSound)
{
   filename    = "fx/weapons/plasma_rifle_projectile_hit.WAV";
   description = AudioClosest3d;
   preload = true;
};

//-----------------------------------
// Particle Effects
//----------------------

//-----------------------------------
// Spark Colors
//----------------------

datablock ParticleData(GenericFireWorkSpark)
{
   textureName          = "special/flare";
};

datablock ParticleData(RedFireWorkSpark) : GenericFireWorkSpark
{
   dragCoefficient      = 0.5;
   gravityCoefficient   = 1;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 2000;
   lifetimeVarianceMS   = 100;
   colors[0]     = "1 0.2 0.2 1.0";
   colors[1]     = "1 0.2 0.2 0";
   sizes[0]      = 5;
   sizes[1]      = 5;
};

datablock ParticleData(BlueFireWorkSpark) : RedFireWorkSpark
{
   colors[0]     = "0.2 0.2 1 1.0";
   colors[1]     = "0.2 0.2 1 0";
};

datablock ParticleData(GreenFireWorkSpark) : RedFireWorkSpark
{
   colors[0]     = "0.2 1 0.2 1.0";
   colors[1]     = "0.2 1 0.2 0";
};

datablock ParticleData(PurpleFireWorkSpark) : RedFireWorkSpark
{
   colors[0]     = "1 0.2 1 1.0";
   colors[1]     = "1 0.2 1 0";
};

datablock ParticleData(YellowFireWorkSpark) : RedFireWorkSpark
{
   colors[0]     = "1 1 0.2 1.0";
   colors[1]     = "1 1 0.2 0";
};

datablock ParticleData(OrangeFireWorkSpark) : RedFireWorkSpark
{
   colors[0]     = "1 0.5 0.1 1.0";
   colors[1]     = "1 0.5 0.1 0";
};

datablock ParticleData(WhiteFireWorkSpark) : RedFireWorkSpark
{
   colors[0]     = "1 1 1 1.0";
   colors[1]     = "1 1 1 0";
};

//---------------------------------
// Sphere Emitters
//---------------------

datablock ParticleEmitterData(RedSparkEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;

   ejectionVelocity = 55;
   velocityVariance = 0;

   ejectionOffset   = 0;

   thetaMin         = 0.0;
   thetaMax         = 180.0;

   phiReferenceVel  = 0.0;
   phiVariance      = 360.0;

   overrideAdvances = false;

   lifeTimeMS       = 300;

   particles = "RedFireWorkSpark";
};

datablock ParticleEmitterData(BlueSparkEmitter) : RedSparkEmitter
{
   particles = "BlueFireWorkSpark";
};

datablock ParticleEmitterData(GreenSparkEmitter) : RedSparkEmitter
{
   particles = "GreenFireWorkSpark";
};

datablock ParticleEmitterData(PurpleSparkEmitter) : RedSparkEmitter
{
   particles = "PurpleFireWorkSpark";
};

datablock ParticleEmitterData(YellowSparkEmitter) : RedSparkEmitter
{
   particles = "YellowFireWorkSpark";
};

datablock ParticleEmitterData(OrangeSparkEmitter) : RedSparkEmitter
{
   particles = "OrangeFireWorkSpark";
};

datablock ParticleEmitterData(WhiteSparkEmitter) : RedSparkEmitter
{
   particles = "WhiteFireWorkSpark";
};

//---------------------------------
// Ring Emitters
//--------------------

datablock ParticleEmitterData(RedRingEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;

   ejectionVelocity = 100;
   velocityVariance = 0;

   ejectionOffset   = 0;

   thetaMin         = 90.0;
   thetaMax         = 90.0;

   phiReferenceVel  = 0.0;
   phiVariance      = 360.0;

   overrideAdvances = false;

   lifeTimeMS       = 0;

   particles = "RedFireWorkSpark";
};

datablock ParticleEmitterData(GreenRingEmitter) : RedRingEmitter
{
   particles = "GreenFireWorkSpark";
};

datablock ParticleEmitterData(BlueRingEmitter) : RedRingEmitter
{
   particles = "BlueFireWorkSpark";
};

datablock ParticleEmitterData(PurpleRingEmitter) : RedRingEmitter
{
   particles = "PurpleFireWorkSpark";
};

datablock ParticleEmitterData(YellowRingEmitter) : RedRingEmitter
{
   particles = "YellowFireWorkSpark";
};

datablock ParticleEmitterData(OrangeRingEmitter) : RedRingEmitter
{
   particles = "OrangeFireWorkSpark";
};

datablock ParticleEmitterData(WhiteRingEmitter) : RedRingEmitter
{
   particles = "WhiteFireWorkSpark";
};

datablock ParticleData(FireWorksSpark) : GenericFireWorkSpark
{
   dragCoefficient      = 0.5;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 2000;
   lifetimeVarianceMS   = 100;
   colors[0]     = "1 0.5 0.1 1.0";
   colors[1]     = "1 0.5 0.1 0";
   sizes[0]      = 1;
   sizes[1]      = 0.3;
};

datablock ParticleEmitterData(FireWorksSparkEmitter) : RedSparkEmitter
{
   ejectionPeriodMS = 5;
   ejectionVelocity = 3;
   thetaMax         = 30.0;

   lifeTimeMS       = 0;
   particles = "FireWorksSpark";
};

//-----------------------------------
// Explosion
//----------------------

datablock ExplosionData(FireWorksExplosionSound)
{
	soundProfile   = FireWorksExpSound;
};

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock LinearProjectileData(FireWorksRocket)
{
   projectileShapeName = "weapon_missile_projectile.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;

   sound 		     = discProjectileSound;
   explosion           = "FireWorksExplosionSound";
   splash              = DiscSplash;

   baseEmitter	     = FireWorksSparkEmitter;

   dryVelocity       = 90;
   wetVelocity       = 50;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 2000;
   lifetimeMS        = 2000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = false;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 2000;

   hasLight    = true;
   lightRadius = 6.0;
   lightColor  = "0.6 0.3 0.1";
};

function FireWorksRocket::onExplode(%data, %proj, %pos, %mod)
{
	CreateEmitter($DefaultEmitter, %proj.ExpEmitter, %pos, 300);
	if(%proj.isFinal)
	{
		StartFireworksFinale(%proj, %pos, 0);
	}
}

function StartFireworksFinale(%proj, %pos, %times)
{
	if(%proj.isFinal == true && %times < 100)
	{
		if(%times > 0)
		{
			%emitPos = %proj.getPosition();
			serverPlay3D(FireWorksExpSound, %proj.getTransform());
			%proj.schedule(100, %proj, "delete");
			CreateEmitter($DefaultEmitter, $randomSparks[getRandom(0,$SparkCount-1)] @"SparkEmitter", %emitPos, 300);
			if(getRandom(0,1) == 1)
			{
				%x = getRandom(-1,1);
				%y = getRandom(-1,1);
				%z = getRandom(-1,1);
				%rot = getRandom(0,90);
				CreateEmitter($DefaultEmitter, $randomSparks[getRandom(0,$SparkCount-1)] @"RingEmitter", %emitPos, 100, %x SPC %y SPC %z SPC %rot);
			}
		}
		%vector = getRandom(-1,1) SPC getRandom(-1,1) SPC getRandom(-1,1);
		%p = new LinearProjectile() {
				datablock = FinaleInvisable;
				initialPosition = %pos;
				initialDirection = %vector;
			};
		MissionCleanup.add(%p);
		%p.isFinal = true;
		schedule(getRandom(100, 1200), 0, "StartFireworksFinale", %p, %pos, %times++);
	}
}

datablock LinearProjectileData(FireWorksRingRocket) : FireWorksRocket
{
   explosion           = "FireWorksExplosionSound";
};

function FireWorksRingRocket::onExplode(%data, %proj, %pos, %mod)
{
	CreateEmitter($DefaultEmitter, $randomSparks[getRandom(0,$SparkCount-1)] @"SparkEmitter", %pos, 300);
	%x = getRandom(-1,1);
	%y = getRandom(-1,1);
	%z = getRandom(-1,1);
	%rot = getRandom(0,90);
	CreateEmitter($DefaultEmitter, $randomSparks[getRandom(0,$SparkCount-1)] @"RingEmitter", %pos, 100, %x SPC %y SPC %z SPC %rot);
}

datablock LinearProjectileData(FinaleInvisable)
{
   projectileShapeName = "turret_muzzlePoint.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;

   sound 		     = discProjectileSound;
   explosion           = "FireWorksExplosionSound";
   splash              = DiscSplash;

   dryVelocity       = 100;
   wetVelocity       = 100;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 1000;
   lifetimeMS        = 1000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = false;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 2000;

   hasLight    = true;
   lightRadius = 6.0;
   lightColor  = "0.6 0.3 0.1";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------

datablock ShapeBaseImageData(FireWorksImage)
{
   className = WeaponImage;
   shapeFile = "weapon_grenade_launcher.dts";
   item = FireWorks;
   offset = "0 0 0";
   emap = true;

   usesEnergy = true;
   minEnergy = 10;
   fireEnergy = 12;

   projectile = FireWorksRocket;
   projectileType = LinearProjectile;

   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;
   stateSequence[1]                 = "Activated";
   stateSound[1]                    = DiscSwitchSound;

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";
   stateSequence[2]                 = "DiscSpin";
   stateSound[2]                    = DiscLoopSound;

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 1.25;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
   stateSound[3]                    = DiscFireSound;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.5;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateSound[4]                    = DiscReloadSound;

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateSound[6]                    = DiscDryFireSound;
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";

};

datablock ItemData(FireWorks)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_grenade_launcher.dts";
   image = FireWorksImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   pickUpName = "a fire works gun";
   emap = true;
};
