//--------------------------------------
// MatrixGun
//--------------------------------------

datablock AudioProfile(MatrixGunFireSound)
{
   filename    = "fx/vehicles/bomber_turret_fire.wav";
   description = AudioDefault3d;
   preload = true;
   effect = BlasterFireEffect;
};

datablock AudioProfile(MatrixGunReloadSound)
{
   filename    = "fx/vehicles/bomber_turret_reload.wav";
   description = AudioDefault3d;
   preload = true;
   effect = BlasterFireEffect;
};

//------------------------------------
// Smoke
//------------------------------------
datablock ParticleData(MatrixGunSmokeParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.2;
   inheritedVelFactor   = 0.00;

   lifetimeMS           = 700;
   lifetimeVarianceMS   = 150;

   textureName          = "particleTest";

   useInvAlpha = false;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "0 0 0 0";
   colors[1]     = "0 0 0 0";
   colors[2]     = "0 0 0 0";

   sizes[0]      = 0.25;
   sizes[1]      = 1.0;
   sizes[2]      = 2.0;

   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(MatrixGunSmokeEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 5;

   ejectionVelocity = 4.0;
   velocityVariance = 0.50;

   thetaMin         = 0.0;
   thetaMax         = 25.0;

   particles = "MatrixGunSmokeParticle";
};

//--------------------------------------------------------------------------
// Shockwave
//--------------------------------------
datablock ShockwaveData(MatrixFXShockwave)
{
   width = 0.12;
   numSegments = 20;
   numVertSegments = 20;
   velocity = 0;
   acceleration = 0.0;
   lifetimeMS = 6000;
   height = 0.12;
   verticalCurve = 0;
   is2D = false;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 1.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1.0 1.0 1.0 0.7";
   colors[1] = "1.0 1.0 1.0 0.35";
   colors[2] = "1.0 1.0 1.0 0.0";

   mapToTerrain = false;
   orientToNormal = true;
   renderBottom = false;
};

//--------------------------------------------------------------------------
// Explosion
//--------------------------------------
datablock ExplosionData(MatrixFXExplosion)
{
   shockwave = MatrixFXShockwave;
   shockwaveOnTerrain = false;
   faceViewer = true;
};

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock LinearProjectileData(MatrixGunBullet)
{
   projectileShapeName = "weapon_missile_projectile.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.3;
   damageRadius        = 1.0;
   radiusDamageType    = $DamageType::Chaingun;
   kickBackStrength    = 50;
   bubbleEmitTime      = 1.0;

   sound 				= GrenadeProjectileSound;
   explosion           = "ChaingunExplosion";
   underwaterExplosion = "ChaingunExplosion";
   splash              = GrenadeSplash;

   baseEmitter         = MatrixGunSmokeEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;

   dryVelocity       = 4.5;
   wetVelocity       = 4.5;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 8000;
   lifetimeMS        = 8000;
   explodeOnDeath    = true;
   explodeOnWaterImpact      = false;
   fizzleUnderwaterMS        = 5000;

   activateDelayMS = -1;

   hasLight    = false;
   lightRadius = 0.0;
   lightColor  = "0.0 0.0 0.0";
};

datablock LinearProjectileData(MatrixFX)
{
   projectileShapeName = "turret_muzzlepoint.dts";
   emitterDelay        = -1;
   directDamage        = 0;
   hasDamageRadius     = false;
   indirectDamage      = 0;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::Default;
   kickBackStrength    = 0;
   bubbleEmitTime      = 0;

   sound 				= GrenadeProjectileSound;
   explosion           = "MatrixFXExplosion";
   underwaterExplosion = "MatrixFXExplosion";
   splash              = GrenadeSplash;

   baseEmitter         = MatrixGunSmokeEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;

   dryVelocity       = 0.1;
   wetVelocity       = 0.1;
   velInheritFactor  = 0;
   fizzleTimeMS      = 0;
   lifetimeMS        = 0;
   explodeOnDeath    = true;
   explodeOnWaterImpact      = false;
   fizzleUnderwaterMS        = 0;

   activateDelayMS = -1;

   hasLight    = false;
   lightRadius = 0.0;
   lightColor  = "0.0 0.0 0.0";
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(MatrixGunAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_disc.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   pickUpName = "some matrix gun bullets";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(MatrixGun)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_energy.dts";
   image = MatrixGunImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   pickUpName = "a matrix gun";
   emap = true;
};

datablock ShapeBaseImageData(MatrixGunImage)
{
   className = WeaponImage;
   shapeFile = "weapon_energy.dts";
   item = MatrixGun;
   ammo = MatrixGunAmmo;
   offset = "0 0 0";
   emap = true;

   projectile = MatrixGunBullet;
   projectileType = LinearProjectile;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;
   stateSequence[1]                 = "Activated";
   stateSound[1]                    = BlasterSwitchSound;

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";
   stateSequence[2]                 = "DiscSpin";
   //stateSound[2]                    = DiscLoopSound;

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.5;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
   stateSound[3]                    = MatrixGunFireSound;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.25; // 0.25 load, 0.25 spinup
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateSound[4]                    = MatrixGunReloadSound;

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateSound[6]                    = SentryTurretExpSound;
   stateTimeoutValue[6]             = 0.75;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

function MatrixGunImage::onFire(%data,%obj,%slot)
{
   %proj = new LinearProjectile() {
      dataBlock        = MatrixGunBullet;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
   };
   MissionCleanup.add(%proj);
   %proj.WeaponMuzVec = %obj.getMuzzleVector(%slot);
   schedule(70,0,"MatrixEffect",%obj,%proj);
   //testobs(MatrixGunBullet,%obj.client,35000);
}

function MatrixGunImage::onExplode(%data, %proj, %pos, %mod)
{
   cancel(%proj.MatrixEffectSchedule);
   Parent::onExplode(%data, %proj, %pos, %mod);
}

function MatrixEffect(%obj,%proj)
{
	if(isObject(%proj))
	{
        %matrixfx = new LinearProjectile() {
		dataBlock        = "MatrixFX";
		initialDirection = %proj.WeaponMuzVec;
		initialPosition  = %proj.position;
		sourceSlot       = %obj;
		};
		%matrixfx.sourceobject = %obj;
		MissionCleanup.add(%matrixfx);
		%proj.MatrixEffectSchedule = schedule(70,0,"MatrixEffect",%obj,%proj);
	}
}
