//--------------------------------------
// Shockwave Cannon
//--------------------------------------

datablock ParticleData(ShockwaveCannonExplosionParticle)
{
    dragCoefficient = 0.341463;
    gravityCoefficient = 0.2;
    windCoefficient = 0;
    inheritedVelFactor = 0.2;
    constantAcceleration = 0;
    lifetimeMS = 2258;
    lifetimeVarianceMS = 88;
    useInvAlpha = 0;
    spinRandomMin = 0;
    spinRandomMax = 0;
    textureName = "special/Explosion/Exp_0040.png";
    times[0] = 0;
    times[1] = 1;
    colors[0] = "0.560000 0.360000 0.260000 1.000000";
    colors[1] = "0.560000 0.360000 0.260000 0.000000";
    sizes[0] = 2.08871;
    sizes[1] = 2;
};

datablock ParticleEmitterData(ShockwaveCannonExplosionEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "ShockwaveCannonExplosionParticle";
};

datablock ShockwaveData(ShockwaveCannonShockwave)
{
   width = 10.0;
   numSegments = 128;
   numVertSegments = 16;
   velocity = 10;
   acceleration = 30;
   lifetimeMS = 750;
   height = 1.0;
   verticalCurve = 0.5;
   is2D = false;

   texture[0] = "special/shockwave4";
   texture[1] = "lightning1frame1.png";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.417323 0.704000 0.096000 0.032258";
   colors[1] = "0.000000 0.288000 0.904000 1.000000";
   colors[2] = "0.560000 0.360000 0.260000 0.000000";

   mapToTerrain = false;
   orientToNormal = false;
   renderBottom = true;
};


datablock ExplosionData(ShockwaveCannonSubExplosion1)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 300;

   offset = 0;

   playspeed  = 0.5;

   sizes[0] = "5 5 5";
   sizes[1] = "5 5 5";
   times[0] = 0.0;
   times[1] = 1.5;

};

datablock ExplosionData(ShockwaveCannonExplosion)
{
   soundProfile   = plasmaExpSound;
   emitter[0] = ShockwaveCannonExplosionEmitter;
   shockwave = ShockwaveCannonShockwave;
};

//-----------------------------
// Projectile
//-----------------------------

datablock LinearFlareProjectileData(ShockwaveCannonBolt)
{
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.01;
   damageRadius        = 15;
   radiusDamageType    = $DamageType::Default;
   kickBackStrength     = 9000;
   explodeOnDeath       = false;

   explosion           = "ShockwaveCannonExplosion";
   splash              = PlasmaSplash;
   velInheritFactor    = 0;

   lifetimeMS          = 7000;
   fizzleTimeMS        = 7000;
   dryVelocity       = 200.0;
   wetVelocity       = 100;
   sound = MissileProjectileSound;

   hasLight    = true;
   lightRadius = 100;
   lightColor  = "1 0.2 0.1";

   explodeOnWaterImpact = true;

   scale             = "3 3 3";
   numFlares         = 0;
   flareColor        = "0.9 0.18 0.07";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(ShockwaveCannon)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_plasma.dts";
   image = ShockwaveCannonImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a Shockwave Cannon";
};

datablock ShapeBaseImageData(ShockwaveCannonImage)
{
   className = WeaponImage;
   shapeFile = "weapon_sniper.dts";
   item = ShockwaveCannon;
   offset = "0 0 0";

   projectile = ShockwaveCannonBolt;
   projectileType = LinearFlareProjectile;
   
   usesEnergy = true;
   fireEnergy = 15;
   minEnergy = 15;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = PlasmaSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "CheckWet";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.1;
   stateFire[3] = true;
   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateScript[3] = "onFire";
   stateEmitterTime[3] = 0.2;
   stateSound[3] = PlasmaFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.6;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = PlasmaReloadSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   stateSound[6]      = PlasmaDryFireSound;
   stateTimeoutValue[6]        = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
   
   stateName[7]       = "WetFire";
   stateSound[7]      = PlasmaFireWetSound;
   stateTimeoutValue[7]        = 1.5;
   stateTransitionOnTimeout[7] = "Ready";
   
   stateName[8]               = "CheckWet";
   stateTransitionOnWet[8]    = "WetFire";
   stateTransitionOnNotWet[8] = "Fire"; 
};

function ShockwaveCannonImage::onmount(%this, %obj, %slot)
{
      %message = "ShockwaveCannon";
      CommandToClient(%obj.client, 'BottomPrint', %message, 2, 1 );
}

datablock ShapeBaseImageData(ShockwaveCannonImage2)
{
   shapeFile = "weapon_elf.dts";
   offset = "0.0 0.0 0.0";
   rotation = "0 1 0 180";
   emap = true;
};

function ShockwaveCannonImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.mountImage(ShockwaveCannonImage2, 1);
}

function ShockwaveCannonImage::onUnmount(%this,%obj,%slot)
{
   Parent::onUnmount(%this, %obj, %slot);
   %obj.unmountImage(1);
}


