datablock ShockwaveData( FakeShocklanceHit )
{
   width = 0.0000001;
   numSegments = 20;
   numVertSegments = 1;
   velocity = 0.00000001;
   acceleration = 1.0;
   lifetimeMS = 0.00000001;
   height = 0.000001;
   verticalCurve = 0.5;

   mapToTerrain = false;
   renderBottom = false;
   orientToNormal = true;

   texture[0] = "special/shocklanceHit";
   texture[1] = "special/gradient";
   texWrap = 3.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1.0 1.0 1.0 1.0";
   colors[1] = "1.0 1.0 1.0 0.5";
   colors[2] = "1.0 1.0 1.0 0.0";
};

function FakeSniperShot::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
{
   %damageAmount = %data.directDamage * %projectile.damageFactor;
   RadiusExplosionDirect(%projectile, %position, 0.1, 0.00001, 400, %projectile.sourceObject, %data.radiusDamageType);

   if(%targetObject.getDataBlock().getClassName() $= "PlayerData")
   {
      %damLoc = firstWord(%targetObject.getDamageLocation(%position));
      if(%damLoc $= "head")
      {
         %targetObject.getOwnerClient().headShot = 1;
         %modifier = %data.rifleHeadMultiplier;
      }
      else
      {
         %modifier = 1;
         %targetObject.getOwnerClient().headShot = 0;
      }
   }
   %targetObject.damage(%projectile.sourceObject, %position, %modifier * %damageAmount, %data.directDamageType);
}
function BasicSniperShot::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
{
}
//--------------------------------------------------------------------------
// Sniper rifle
//
//
//--------------------------------------------------------------------------


datablock AudioProfile(SniperRifleSwitchSound)
{
   filename    = "fx/weapons/sniper_activate.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(SniperRifleFireSound)
{
//   filename    = "fx/weapons/sniper_fire.wav";
   filename    = "fx/vehicles/bomber_turret_fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SniperRifleFireWetSound)
{
   filename    = "fx/weapons/sniper_underwater.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SniperRifleDryFireSound)
{
   filename    = "fx/weapons/chaingun_dryfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SniperRifleProjectileSound)
{
   filename    = "fx/weapons/sniper_miss.wav";
   description = AudioClose3d;
   preload = true;
};


//--------------------------------------------------------------------------
// Splash
//--------------------------------------------------------------------------
datablock ParticleData( SniperSplashParticle )
{

   dragCoeffiecient     = 0.4;
   gravityCoefficient   = -0.03;   // rises slowly
   inheritedVelFactor   = 0.025;

   lifetimeMS           = 600;
   lifetimeVarianceMS   = 300;

   textureName          = "particleTest";

   useInvAlpha =  false;
   spinRandomMin = -200.0;
   spinRandomMax =  200.0;


   colors[0]     = "0.7 0.8 1.0 1.0";
   colors[1]     = "0.7 0.8 1.0 0.5";
   colors[2]     = "0.7 0.8 1.0 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 1.0;
   sizes[2]      = 2.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( SniperSplashEmitter )
{
   ejectionPeriodMS = 25;
   ejectionOffset = 0.2;
   periodVarianceMS = 0;
   ejectionVelocity = 2.25;
   velocityVariance = 0.50;
   thetaMin         = 0.0;
   thetaMax         = 30.0;
   lifetimeMS       = 250;

   particles = "SniperSplashParticle";
};

datablock SplashData( SniperSplash )
{
   numSegments = 5;
   ejectionFreq = 0.0001;
   ejectionAngle = 45;
   ringLifetime = 0.5;
   lifetimeMS = 400;
   velocity = 5.0;
   startRadius = 0.0;
   acceleration = -3.0;
   texWrap = 5.0;

   texture = "special/water2";

   emitter[0] = SniperSplashEmitter;

   colors[0] = "0.7 0.8 1.0 0.0";
   colors[1] = "0.7 0.8 1.0 1.0";
   colors[2] = "0.7 0.8 1.0 0.0";
   colors[3] = "0.7 0.8 1.0 0.0";
   times[0] = 0.0;
   times[1] = 0.4;
   times[2] = 0.8;
   times[3] = 1.0;
};

//--------------------------------------------------------------------------
// Explosion
//--------------------------------------
datablock AudioProfile(sniperExpSound)
{
   filename    = "fx/weapons/grenade_explode.WAV";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(SniperExplosionParticle1)
{
   dragCoefficient      = 0.65;
   gravityCoefficient   = 0.3;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 0.000001;//800
   lifetimeVarianceMS   = 0.0001;//150
   textureName          = "special/expflare";
   colors[0]     = "0 0 1 1.0";
   colors[1]     = "0 0 1 0.0";
   sizes[0]      = 0.0625;
   sizes[1]      = 0.2;
};

datablock ParticleEmitterData(SniperExplosionEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 0.75;
   velocityVariance = 0.25;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 360;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "SniperExplosionParticle1";
};
datablock ShockwaveData(LaserShockwave)
{
   width = 3.0;
   numSegments = 20;
   numVertSegments = 2;
   velocity = 8;
   acceleration = -2.0;
   lifetimeMS = 400;
   height = 0.00001;
   verticalCurve = 0.000000001;

   mapToTerrain = false;
   renderBottom = true;
   orienttonormal = true;
   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.8 0.8 0.8 1.00";
   colors[1] = "0.8 0.5 0.2 0.20";
   colors[2] = "1.0 0.5 0.5 0.0";
};

datablock ExplosionData(SniperExplosion)
{
   soundProfile   = sniperExpSound;
//   shockwave =  LaserShockwave;
//   particleEmitter = SniperExplosionEmitter;
//   particleDensity = 150;
//   particleRadius = 0.25;

   faceViewer           = false;
};
datablock ExplosionData(SniperExplosion2)
{
   soundProfile   = sniperExpSound;
   faceViewer           = true;
//   explosionShape = "effect_plasma_explosion.dts";
//playspeed = 3;
//shockwave =  LaserShockwave;
};


//--------------------------------------
// Projectile
//--------------------------------------
datablock SniperProjectileData(BasicSniperShot)
{
   directDamage        = 0.4;
   hasDamageRadius     = false;
   indirectDamage      = 0.0;
   damageRadius        = 0.0;
   velInheritFactor    = 1.0;
   sound 				  = SniperRifleProjectileSound;
   explosion           = "SniperExplosion2";
   splash              = SniperSplash;
   directDamageType    = $DamageType::Laser;

   maxRifleRange       = 1500;
   rifleHeadMultiplier = 1.3;
   beamColor           = "0 0 1";
   fadeTime            = 0.6;

   startBeamWidth		  = 0.1;
   endBeamWidth 	     = 0.01;
   pulseBeamWidth 	  = 0.5;
   beamFlareAngle 	  = 3.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 400.0;
   pulseSpeed          = -0.2;
   pulseLength         = 0.03;

   lightRadius         = 1.0;
   lightColor          = "0.0 0.3 1.0";

   textureName[0]      = "special/flare";
   textureName[1]      = "special/bubbles";
   textureName[2]      = "special/bubbles";
   textureName[3]      = "special/shocklancezap";
   textureName[4]      = "special/skylightning";
   textureName[5]      = "special/bubbles";
   textureName[6]      = "special/skylightning";
   textureName[7]      = "special/bubbles";
   textureName[8]      = "special/skylightning";
   textureName[9]      = "special/bubbles";
   textureName[10]     = "special/tracer00";
   textureName[11]     = "special/nonlingradient";//skylightning

};
datablock ShockLanceProjectileData(SniperShock)
{
   directDamage        = 10.00000001;
   radiusDamageType    = $DamageType::ShockLance;
   kickBackStrength    = 0.0001;
   velInheritFactor    = 0;
   sound               = "";

   zapDuration = 0.6;
   impulse = 1800;
   boltLength = 17.0;
   extension = 17.0;  //i dont think you need this
   lightningFreq = 25.0;
   lightningDensity = 3.0;
   lightningAmp = 0.25;
   lightningWidth = 0.05;

   shockwave = FakeShocklanceHit;

   boltSpeed[0] = 2.0;
   boltSpeed[1] = -0.5;

   texWrap[0] = 1.5;
   texWrap[1] = 1.5;

   startWidth[0] = 0.000001;
   endWidth[0] = 0.0000001;
   startWidth[1] = 0.000001;
   endWidth[1] = 0.00001;

   texture[0] = "special/shockLightning01";
   texture[1] = "special/shockLightning02";
   texture[2] = "special/shockLightning03";
   texture[3] = "special/elfbeam";
};
datablock SniperProjectileData(FakeSniperShot)
{
   directDamage        = 10.4;
   hasDamageRadius     = false;
   indirectDamage      = 0.0;
   damageRadius        = 0.0;
   velInheritFactor    = 1.0;
   sound 				  = SniperRifleProjectileSound;
   explosion           = "SniperExplosion";
   splash              = SniperSplash;
   directDamageType    = $DamageType::Laser;

   maxRifleRange       = 1999;
   rifleHeadMultiplier = 1.3;
   beamColor           = "1 0.3 0.1";
   fadeTime            = 0.00001;

   startBeamWidth		  = 0.00001;
   endBeamWidth 	     = 0.00001;
   pulseBeamWidth 	  = 0.5;
   beamFlareAngle 	  = 0.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 0.0;
   pulseSpeed          = -0.2;
   pulseLength         = 0.03;

   lightRadius         = 0.1;
   lightColor          = "0.0 0.3 1.0";

   textureName[0]      = "special/flare";
   textureName[1]      = "special/bubbles";
   textureName[2]      = "special/bubbles";
   textureName[3]      = "special/shocklancezap";
   textureName[4]      = "special/skylightning";
   textureName[5]      = "special/bubbles";
   textureName[6]      = "special/skylightning";
   textureName[7]      = "special/bubbles";
   textureName[8]      = "special/skylightning";
   textureName[9]      = "special/bubbles";
   textureName[10]     = "special/tracer00";
   textureName[11]     = "special/nonlingradient";//skylightning

};

//--------------------------------------
// Rifle and item...
//--------------------------------------
//datablock ItemData(SniperAmmo)
//{
//   className = Ammo;
//   catagory = "Ammo";
//   shapeFile = "ammo_disc.dts";
//   mass = 1;
//   elasticity = 0.2;
//   friction = 0.6;
//   pickupRadius = 2;
//	pickUpName = "some shock capacitors";
//};
datablock ItemData(SniperRifle)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = "weapon_sniper.dts";
   image        = SniperRifleImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
	pickUpName = "a ASMD Shockrifle";
emap = true;

   computeCRC = true;

};
datablock ShapeBaseImageData(SniperRifleImage)
{
	className = WeaponImage;
   shapeFile = "weapon_sniper.dts";
   item = SniperRifle;
   projectile = BasicSniperShot;
   projectileType = SniperProjectile;
	armThread = looksn;

 usesEnergy = true;
   fireEnergy = 4;
   minEnergy = 4;

   //ammo = SniperAmmo;
offset = "0.06 0 -0.1";
emap = true;
   stateName[0]                     = "Activate";
   stateTransitionOnTimeout[0]      = "ActivateReady";
   stateSound[0]                    = SniperRifleSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateSequence[0]                 = "Activate";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnLoaded[1]       = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "CheckWet";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 2;
   stateShockwave[3]           = false;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
//   staterecoil[3]                   = "lightrecoil";

   stateName[4]                     = "Reload";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.5;
   stateAllowImageChange[4]         = false;

   stateName[5]                     = "CheckWet";
   stateTransitionOnWet[5]          = "DryFire";
   stateTransitionOnNotWet[5]       = "Fire";

   stateName[6]                     = "NoAmmo";
   stateTransitionOnAmmo[6]         = "Reload";
   stateTransitionOnTriggerDown[6]  = "DryFire";
   stateSequence[6]                 = "NoAmmo";

   stateName[7]                     = "DryFire";
   stateSound[7]                    = SniperRifleDryFireSound;
   stateTimeoutValue[7]             = 0.5;
   stateTransitionOnTimeout[7]      = "Ready";
};

function CreateShockwave(%obj, %Vect, %Shockwave, %emitTime)
{
   	if(isObject(%obj))
	{
		%Shock = new shockwave()
			{
			pos = %obj.getPosition();
			normal = %Vect;
			datablock = %Shockwave;
   			};
		MissionCleanup.add(%Shock);
		if(%emitTime)
		{
			schedule(%emitTime,0, "CreateShockwave", %obj, %Vect, %Shockwave, %emitTime);
		}
		return %Shock;
	}
}


datablock ShapeBaseImageData(LaserWaveImage) : SniperRifleImage
{
shapeFile = "turret_muzzlepoint.dts";
offset = "0 1.15 0.06";
stateShockwave[3]           = false;
};
function SniperRifleImage::onMount(%this, %obj, %slot, %client)
{
Parent::onMount(%this, %obj, %slot);
//%obj.mountImage(LaserWaveImage, 1);
}
function SniperRifleImage::onUnmount(%this,%obj,%slot)
{
Parent::onUnmount(%this, %obj, %slot);
//%obj.unmountImage(1);
}
function LaserWaveImage::onFire(%data, %obj, %slot)
{
%obj.setImageTrigger(0, false);
%obj.setImageTrigger(1, false);
%p = Parent::onFire(%data,%obj,%slot);
CreateShockwave(%p, %p.getMuzzleVector, "ScoutChaingunHit", 100);

}
exec("scripts/weapons/ASMDExtra.cs");

